//==============================================================================
// LocalSTL.hh
// ---------------------------------------------------------------------------
// Includes the system-specific implementation of STL, the Standard Template 
// Library, and the C++ standard libraries (sometimes these are bundled 
// together, sometimes they are kept separate).  
//
//-----------------------------------------------------------------------------
// $Id:$
//-----------------------------------------------------------------------------
// $Log:$
//
//==============================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8
//

#ifndef _LOCAL_STL
#define _LOCAL_STL

#include <vector>
#include <string>
#include <deque>
#include <algorithm>
#include <set>
#include <map>
#include <fstream>
#include <string>
#include <string.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;


// Forte64
#ifdef FORTE64

#include <hash_map>
#include <hash_set>
#include <strstream.h>

typedef ifstream izipstream;
typedef ofstream ozipstream; 

#else 


// As of GCC 3.0, these have been moved to an ext sub directory, I guess
// because they are extensions to the STL, and not part of the STL itself. 
// 
// In 3.3 strstream has been deprecated, for some reason. It's still in 
// backward compatibility directory. 
// 
#ifdef GCC3

// For some reason, they've moved hash_map into __gnu_cxx.  Fine 
// that it isn't standard so shouldn't go in std::, but why such an 
// ugly thing as __gnu_cxx?  Also, setting the namespace and including
// algobase.h is done by <backward/hash_map.h>.  Perhaps I should be 
// including it that way.  Not sure...   I sure hope hash_map isn't 
// on the way out. 
//
using namespace __gnu_cxx;

#include "algobase.h"
#include <ext/hash_map>
#include <ext/hash_set>
#include <backward/strstream>

// We've switched from using zipiostream to gzstream. 
// This maps the names so all the source doesn't have to 
// be changed.
#include "gzstream.h"
typedef igzstream izipstream;
typedef ogzstream ozipstream;

#else 

#include <hash_map>
#include <hash_set>

#include <strstream.h>

//#include "zipiostream.hh"
#include "gzstream.h"
typedef igzstream izipstream;
typedef ogzstream ozipstream;


#endif // else not GCC3
#endif// else not FORTE64


// Used by RandomNumberGenerator 
typedef long local_time_type;

// 
typedef vector<string> stringVec;   // Stop-gap bug work around.


#endif	// ifndef _LOCAL_STL


















