#!/home/hgsc/bin/perl  -w 

use Getopt::Long;
use File::Basename;
use Cwd;
use RCHEN::Scaffold;
use Bcm::LSF;
use Mail::Mailer;

# Assume done until proven otherwise.
$all_good_status="DONE";

$opt_prj = "ghcm_kbrb";
$output_root="/users/pipeline/p-atlas/atlas/freeze04-stitch";
$opt_pdir= $output_root."/output/";

if (!GetOptions(
					 "help|h",
					 "pdir|d:s",
					 "prj|p:s"					 
					 )) {
    usage(1);
}

#$pdir = "/users/pipeline/p-atlas/atlas/freeze01-stitched/output/$opt_prj";
#$pdir = "/users/pipeline/p-atlas/atlas-temp/freeze02-wavestitch/output/$opt_prj";
$pdir = $opt_pdir.$opt_prj;
#$pdir = "/users/pipeline/p-atlas/projects/$opt_prj/current";

$ace=	 "$pdir/$opt_prj.ace.gz";
$qual = "$pdir/$opt_prj.qual.gz";
$splitace = "$pdir/split.ace";
$problem = "$pdir/check";
$scaffoldsplit = "$pdir/scaffold.split";
$scaffoldtrim = "$pdir/scaffold.trim";
$trimace = "$pdir/trim.ace";
$finalace = "$pdir/bactig.final.ace.gz";
$finalscaffold = "$pdir/bactig.final.scaffold";
$linearout = "$pdir/bactig.final.fa";

$statname = $output_root."/status2/$opt_prj.stat";

open(STAT,">$statname") || die "Can't open $statname\n";
STAT->autoflush(1);
print STAT "START\n";


#main 
{

# Save whatever was there.  This is only for late in the game. 
#$savedir = "$pdir/save";
#$mkcmd = "mkdir $savedir";
#system($mkcmd);

#$mvcmd = "mv -f $pdir/* $savedir";
#RunCommand($mvcmd);

$cleanCmd = "rm -f $splitace.gz $trimace.gz";
RunCommand($cleanCmd);

# CHECK
$chkCmd ="/home/grok2/pathbuilder/bin/link-check-contig.pl -o $problem $ace";
print "$chkCmd\n";
RunCommand($chkCmd);

# SPLIT
# Ray's code: -M 5000 -w 20 -c 1 
$splitCmd = "/home/hgsc/bin/atlas-splitbadcontigs-1.361 -a $ace -p $problem -q $qual -o $splitace -M 5000 -w 20 -c 1";
print "$splitCmd\n";
RunCommand($splitCmd);

# SCAFFOLD
$scaffoldCmd = "/home/grok2/pathbuilder/bin/link-build-scaffold-file2.pl -o $scaffoldsplit $splitace";
print "$scaffoldCmd\n";
RunCommand($scaffoldCmd);

# TRIM 
# -w 20 -c 1 -M 2000
$trimCmd = "/home/hgsc/bin/atlas-trimphraptails-1.161 -a $splitace -q $qual -o $trimace -g $scaffoldsplit -M 2000 -w 20 -c 1";
print "$trimCmd\n";
RunCommand($trimCmd);

# SCAFFOLD 
#
$scaffoldCmd = "/home/grok2/pathbuilder/bin/link-build-scaffold-file2.pl -o $scaffoldtrim $trimace";
print "$scaffoldCmd\n";
RunCommand($scaffoldCmd);

# count number of scaffolds > 15K split/trim. Take smaller ones.  
# get function from Ray.  
# /home/grok2/pathbuilder/bin/bactig-generate-scaffold.pl    sub parse_scaffold();


# GZIP trim
$gzipCmd = "gzip $trimace";
print "$gzipCmd\n";
RunCommand($gzipCmd);

# GZIP split
$gzipCmd = "gzip $splitace";
print "$gzipCmd\n";
RunCommand($gzipCmd);


# PICK FINAL 
#pick the better scaffold and final ace accordingly
my $counttrim=&parse_scaffold($scaffoldtrim);
my $countsplit=&parse_scaffold($scaffoldsplit);

print "Count trim= $counttrim\n";
print "Count split= $countsplit\n";

if($countsplit<$counttrim) {
		#take the split one as the final
		$cmd = "ln -s $splitace.gz $finalace";
		RunCommand($cmd);
		$cmd = "ln -s $scaffoldsplit $finalscaffold";
		RunCommand($cmd);
} else {
		#take the trim one as the final
		$cmd = "ln -s $trimace.gz $finalace";
		RunCommand($cmd);
		$cmd = "ln -s $scaffoldtrim $finalscaffold";
		RunCommand($cmd);
}

$linearCmd = "/home/hgsc/bin/atlas-linearsequence-1.40 -a $finalace -g $finalscaffold -o $linearout -s 2000 -Q 1 ";
print "$linearCmd\n";
RunCommand($linearCmd);


#$cleanCmd = "rm -f $splitace";
#RunCommand($cleanCmd);

print STAT "$all_good_status\n";
close(STAT);

exit(1)
}

sub parse_scaffold {
    my $file=shift;

    my $count=0;
    open(SCA, $file) || die "cannot open $file to read\n";
    while(<SCA>) {
				chomp;
				if(/^SCAFFOLD:\s+(\S+).+?(\S+)$/) {
						if($2>15000) {
								$count++;
						}
				}
    }
    return $count;
}


# Run a command, recording the command and it's status in the status file. 
sub RunCommand()
{
	 my $cmd = shift;
	 print STAT "$cmd\n";
	 $status = system($cmd);
	 
	 if ($status != 0) {
		  $all_good_status = "FAIL";
	 }
	 print STAT "status = $status\n";	 
}


